/*
 * Copyright 2009 Brian Pellin.
 *     
 * This file is part of KeePassDroid.
 *
 *  KeePassDroid is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  KeePassDroid is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with KeePassDroid.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package com.keepassdroid.database;

public abstract class PwDbHeader {

	public static final int PWM_DBSIG_1 = 0x9AA2D903;

	/** Seed that gets hashed with the userkey to form the final key */
	public byte masterSeed[];

	/** Used for the dwKeyEncRounds AES transformations */
	public byte transformSeed[] = new byte[32];

	/** IV used for content encryption */
	public byte encryptionIV[] = new byte[16];
	
}
